"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var jsx_runtime_1 = require("react/jsx-runtime");
var __1 = require("..");
var helper_1 = tslib_1.__importDefault(require("../../utils/helper"));
require("./IconsList.component.scss");
var IconTile = function (props) {
    var icon = props.icon;
    return ((0, jsx_runtime_1.jsxs)("span", { className: "c-IconTile d-inline-block mx-2 mb-3 border", onClick: function () {
            var iconLink = "http://localhost:8080/icon/".concat(icon.group, "/").concat(icon.name);
            navigator.clipboard.writeText(iconLink);
            // TODO: replace below line with a dispatcher to show notification
            // alert("Copied link to clipboard: " + iconLink)
        }, children: [(0, jsx_runtime_1.jsx)("div", { className: "c-IconTile__image text-center", children: (0, jsx_runtime_1.jsx)("img", { className: "h-100", src: "data:image/svg+xml;utf8,".concat(icon.svg), alt: "icon" }) }), (0, jsx_runtime_1.jsx)("footer", { className: "fw-bold text-nowrap overflow-hidden flex-center", children: icon.name })] }));
};
var IconsList = function (props) {
    var icons = props.icons, onSearchChanged = props.onSearchChanged;
    var slices = icons &&
        icons.length > 0 &&
        helper_1.default.generateSlices(icons.length, 100, "index");
    return ((0, jsx_runtime_1.jsxs)("div", { className: "c-IconsList h-100 w-100 overflow-auto p-3", children: [(0, jsx_runtime_1.jsx)("div", { className: "c-IconsList__header-pagination-search py-2 px-3 mb-3 border", children: (0, jsx_runtime_1.jsxs)("div", { className: "row", children: [(0, jsx_runtime_1.jsx)("div", { className: "col-2 d-flex align-items-center", children: (0, jsx_runtime_1.jsx)("h6", { className: "mb-0", children: "Icon Repository" }) }), (0, jsx_runtime_1.jsx)("div", { className: "col-7 flex-center", children: slices && (0, jsx_runtime_1.jsx)(__1.Pagination, { data: slices, maxPillsToShow: 5 }) }), (0, jsx_runtime_1.jsx)("div", { className: "col-3", children: (0, jsx_runtime_1.jsx)(__1.Search, { classes: "bg-white h-100", placeholder: "Search by name, tags, description", onChange: function (event) {
                                    return onSearchChanged(event.target.value);
                                }, data: icons
                                    ? icons.map(function (icon) { return ({
                                        label: icon.name,
                                        data: icon,
                                    }); })
                                    : [] }) })] }) }), (0, jsx_runtime_1.jsx)("div", { className: "c-IconsList__icon-tile-container py-2 px-3 border d-flex justify-content-between flex-wrap", children: icons &&
                    icons
                        .slice(0, 100)
                        .map(function (icon, index) { return (0, jsx_runtime_1.jsx)(IconTile, { icon: icon }, index); }) })] }));
};
exports.default = IconsList;
//# sourceMappingURL=IconsList.js.map