"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var __1 = require("../..");
var helper_1 = tslib_1.__importDefault(require("../../../utils/helper"));
require("./Filters.component.scss");
var Filters = function (props) {
    var config = props.config, data = props.data, initialFilters = props.initialFilters, onFilterChange = props.onFilterChange;
    var _a = tslib_1.__read((0, react_1.useState)(initialFilters), 2), filters = _a[0], setFilters = _a[1];
    var total = data && data.length;
    var countOptions = helper_1.default.generateSlices(total || 0, config.count || 0, "range");
    var onLocalFilterChange = function (data, type) {
        var filterClone = filters ? tslib_1.__assign({}, filters) : {};
        var existing = filterClone[type];
        if (existing &&
            type !== "count" &&
            data &&
            type === "alphabet" &&
            "value" in existing &&
            "value" in data &&
            existing.value === data.value) {
            filterClone[type] = undefined;
        }
        else {
            filterClone[type] = data;
        }
        setFilters(filterClone);
        onFilterChange && onFilterChange(filterClone);
    };
    return ((0, jsx_runtime_1.jsxs)("div", { className: "c-Filters p-3 h-100 overflow-auto", children: [(0, jsx_runtime_1.jsx)("h4", { children: "Filters" }), "count" in config && ((0, jsx_runtime_1.jsx)(__1.DropDown, { context: "count", id: "icon-range-selector", label: "Select a range", options: countOptions, onSelectionChanged: function (data) {
                    onLocalFilterChange(data, "count");
                } })), config.alphabet && ((0, jsx_runtime_1.jsx)(__1.AlphabetFilter, { onSelectionChanged: onLocalFilterChange })), "categories" in config && ((0, jsx_runtime_1.jsx)(__1.CategoryFilter, { categoryGroups: helper_1.default.generateCategories(data, config.categories), onCategorySelection: function (data, category) {
                    var categories = filters && filters.categories ? filters.categories : new Map();
                    "set" in categories && categories.set(category, data);
                    onLocalFilterChange(categories, "categories");
                } }))] }));
};
exports.default = Filters;
//# sourceMappingURL=Filters.js.map