"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var components_1 = require("../../components");
var Footer_1 = tslib_1.__importDefault(require("../../components/Footer"));
var Main_1 = tslib_1.__importDefault(require("../../components/Main"));
var Header_1 = tslib_1.__importDefault(require("../../components/Header"));
var IconsList_1 = tslib_1.__importDefault(require("../../components/IconsList"));
var network_1 = tslib_1.__importDefault(require("../../utils/network"));
var helper_1 = tslib_1.__importDefault(require("../../utils/helper"));
require("./Icons.page.scss");
var fetchData = function (setIcons) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var response;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, network_1.default.getStatic("/icons", null, null)];
            case 1:
                response = _a.sent();
                setIcons(response.body);
                return [2 /*return*/];
        }
    });
}); };
var Icons = function (props) {
    var _a = tslib_1.__read((0, react_1.useState)(), 2), icons = _a[0], setIcons = _a[1];
    var _b = tslib_1.__read((0, react_1.useState)(), 2), searchText = _b[0], setSearchText = _b[1];
    var _c = tslib_1.__read((0, react_1.useState)(), 2), filteredIcons = _c[0], setFilteredIcons = _c[1];
    var _d = tslib_1.__read((0, react_1.useState)({
        count: {
            value: "1to1000",
            data: new Map([
                ["startIndex", 0],
                ["endIndex", 999],
            ]),
        },
    }), 2), filters = _d[0], setFilters = _d[1];
    (0, react_1.useEffect)(function () {
        !icons && fetchData(setIcons);
    }, [icons]);
    (0, react_1.useEffect)(function () {
        if (icons) {
            var finalFilteredIconList_1 = icons;
            if (searchText) {
                finalFilteredIconList_1 = helper_1.default.recrusiveFilter(finalFilteredIconList_1, searchText, false, ["name"]);
            }
            if (filters && finalFilteredIconList_1) {
                var countFilter = filters.count && "data" in filters.count && filters.count.data;
                if (countFilter) {
                    finalFilteredIconList_1 = finalFilteredIconList_1.slice(countFilter.get("startIndex"), countFilter.get("endIndex"));
                }
                var alphabet_1 = filters.alphabet &&
                    "value" in filters.alphabet &&
                    filters.alphabet.value;
                if (alphabet_1) {
                    finalFilteredIconList_1 = finalFilteredIconList_1.filter(function (icon) {
                        return icon.name.toLowerCase().startsWith(alphabet_1.toLowerCase());
                    });
                }
                var categories = filters.categories && filters.categories;
                if (categories) {
                    Array.from(categories.keys()).forEach(function (category) {
                        finalFilteredIconList_1 = finalFilteredIconList_1 === null || finalFilteredIconList_1 === void 0 ? void 0 : finalFilteredIconList_1.filter(function (icon) {
                            return icon.group === category;
                        });
                    });
                }
            }
            setFilteredIcons(finalFilteredIconList_1);
        }
    }, [filters, icons, searchText]);
    return ((0, jsx_runtime_1.jsxs)("div", { className: "c-Icons vh-100 d-flex flex-column", children: [(0, jsx_runtime_1.jsx)(Header_1.default, {}), (0, jsx_runtime_1.jsx)(Main_1.default, { drawerContent: (0, jsx_runtime_1.jsx)(components_1.Filters, { config: { count: 1000, alphabet: true, categories: ["group"] }, data: icons, initialFilters: filters, onFilterChange: setFilters }), 
                // mainContent={<IconsList icons={filteredIcons || icons} />}
                mainContent: (0, jsx_runtime_1.jsx)(IconsList_1.default, { icons: filteredIcons, onSearchChanged: setSearchText }) }), (0, jsx_runtime_1.jsx)(Footer_1.default, {})] }));
};
exports.default = Icons;
//# sourceMappingURL=Icons.js.map