"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var Helper = /** @class */ (function () {
    function Helper() {
    }
    Helper.populateComponentsInRoutes = function (routes, components) {
        routes &&
            routes.forEach(function (route) {
                var Component = components[route.element];
                route.element = (0, jsx_runtime_1.jsx)(Component, {});
                if (route.children) {
                    Helper.populateComponentsInRoutes(route.children, components);
                }
            });
    };
    Helper.recrusiveFilter = function (data, filter, matchCase, searchProps) {
        if (!filter || !data || data.length === 0) {
            return data;
        }
        if (!searchProps || searchProps.length === 0) {
            searchProps = ["label"];
        }
        var dataClone = JSON.parse(JSON.stringify(data));
        var filteredItems = dataClone.filter(function (obj) {
            return (searchProps &&
                searchProps.reduce(function (acc, prop) {
                    var isMatch = obj[prop] &&
                        (matchCase
                            ? obj[prop].indexOf(filter) > -1
                            : obj[prop].toLowerCase().indexOf(filter.toLowerCase()) > -1);
                    if (obj.children) {
                        obj.children = Helper.recrusiveFilter(obj.children, filter, matchCase);
                        isMatch = isMatch || obj.children.length > 0;
                    }
                    return acc || isMatch;
                }, false));
        });
        return filteredItems;
    };
    Helper.generateSlices = function (count, sliceLength, labelFormat) {
        var i = 0, j = 0;
        var slices = [];
        while (i < count) {
            var addUp = sliceLength;
            if (i + sliceLength > count) {
                addUp = count % sliceLength;
            }
            var label = labelFormat === "range" ? i + 1 + " - " + (i + addUp) : "" + (j + 1);
            slices.push(new Map([
                ["label", label],
                ["name", label.replace(/ /g, "").replace(/-/g, "to")],
                ["sliceIndex", j],
                ["startIndex", i],
                ["endIndex", i + addUp - 1],
            ]));
            i += sliceLength;
            j++;
        }
        return slices;
    };
    Helper.aggregate = function (data, aggregator) {
        var aggregated = new Map();
        data.forEach(function (item) {
            var key = item[aggregator];
            var aggregatedArray = aggregated.get(key);
            if (!aggregatedArray) {
                aggregatedArray = [];
                aggregated.set(key, aggregatedArray);
            }
            aggregatedArray.push(item);
        });
        return aggregated;
    };
    Helper.generateCategories = function (data, categories) {
        var groups = new Map();
        if (categories && data) {
            categories.forEach(function (key) {
                var group = Helper.aggregate(data, key);
                groups.set(key, group);
            });
        }
        return groups;
    };
    Helper.toCamelCase = function (str, separater, includeFirst) {
        var strParts = str.split(separater || " ");
        return strParts
            .map(function (part, i) {
            return i === 0 && includeFirst
                ? part.charAt(0).toUpperCase() + part.slice(1)
                : part;
        })
            .join("");
    };
    return Helper;
}());
exports.default = Helper;
//# sourceMappingURL=helper.js.map