import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Pagination, Search } from "..";
import Helper from "../../utils/helper";
import "./IconsList.component.scss";
var IconTile = function (props) {
    var icon = props.icon;
    return (_jsxs("span", { className: "c-IconTile d-inline-block mx-2 mb-3 border", onClick: function () {
            var iconLink = "http://localhost:8080/icon/".concat(icon.group, "/").concat(icon.name);
            navigator.clipboard.writeText(iconLink);
            // TODO: replace below line with a dispatcher to show notification
            // alert("Copied link to clipboard: " + iconLink)
        }, children: [_jsx("div", { className: "c-IconTile__image text-center", children: _jsx("img", { className: "h-100", src: "data:image/svg+xml;utf8,".concat(icon.svg), alt: "icon" }) }), _jsx("footer", { className: "fw-bold text-nowrap overflow-hidden flex-center", children: icon.name })] }));
};
var IconsList = function (props) {
    var icons = props.icons, onSearchChanged = props.onSearchChanged;
    var slices = icons &&
        icons.length > 0 &&
        Helper.generateSlices(icons.length, 100, "index");
    return (_jsxs("div", { className: "c-IconsList h-100 w-100 overflow-auto p-3", children: [_jsx("div", { className: "c-IconsList__header-pagination-search py-2 px-3 mb-3 border", children: _jsxs("div", { className: "row", children: [_jsx("div", { className: "col-2 d-flex align-items-center", children: _jsx("h6", { className: "mb-0", children: "Icon Repository" }) }), _jsx("div", { className: "col-7 flex-center", children: slices && _jsx(Pagination, { data: slices, maxPillsToShow: 5 }) }), _jsx("div", { className: "col-3", children: _jsx(Search, { classes: "bg-white h-100", placeholder: "Search by name, tags, description", onChange: function (event) {
                                    return onSearchChanged(event.target.value);
                                }, data: icons
                                    ? icons.map(function (icon) { return ({
                                        label: icon.name,
                                        data: icon,
                                    }); })
                                    : [] }) })] }) }), _jsx("div", { className: "c-IconsList__icon-tile-container py-2 px-3 border d-flex justify-content-between flex-wrap", children: icons &&
                    icons
                        .slice(0, 100)
                        .map(function (icon, index) { return _jsx(IconTile, { icon: icon }, index); }) })] }));
};
export default IconsList;
//# sourceMappingURL=IconsList.js.map