import { __read } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from "react";
import { Icon, Search } from "../..";
import "./TreeList.component.scss";
var generateRenders = function (data, i, onItemSelect) {
    return (data && (_jsx("ul", { className: "c-TreeList__list list-unstyled", children: data.map(function (obj, index) { return (_jsx(TreeListItem, { hierarchyLevel: i, data: obj, onItemSelect: onItemSelect }, "TreeListItem" + index)); }) })));
};
var TreeListItem = function (props) {
    var hierarchyLevel = props.hierarchyLevel, data = props.data, onItemSelect = props.onItemSelect;
    var _a = __read(useState(data.expanded), 2), expanded = _a[0], setExpanded = _a[1];
    var children = null;
    if (data.children) {
        children = generateRenders(data.children, hierarchyLevel + 1, onItemSelect);
    }
    var handleItemClick = function () {
        data.onItemSelect && data.onItemSelect(data);
        if (onItemSelect && !data.skipParentSelector) {
            onItemSelect(data);
        }
        else {
            console.warn("Parent Selector not called due to the tree item property skipParentSelector!");
        }
        children && setExpanded(!expanded);
    };
    return (_jsxs("li", { className: "c-TreeListItem".concat(!expanded ? " expanded" : ""), children: [_jsxs("span", { className: "d-inline-block py-2 w-100", style: {
                    paddingLeft: hierarchyLevel > 0 ? 1.25 + 0.8 * hierarchyLevel + "rem" : 0,
                }, onClick: handleItemClick, children: [children && (_jsx(Icon, { containerClasses: "me-1", src: "http://localhost:8080/icon/md/MdKeyboardArrowRight" })), data.label] }), children] }));
};
var TreeList = function (props) {
    var data = props.data, firstExpanded = props.firstExpanded, noSearch = props.noSearch, onItemSelect = props.onItemSelect, title = props.title;
    var _a = __read(useState(), 2), filteredItems = _a[0], setFilteredItems = _a[1];
    // Set first item expanded
    firstExpanded && data && data[0] && (data[0].expanded = true);
    return (_jsxs("div", { className: "c-TreeList mx-1", children: [title && _jsx("strong", { className: "d-block mb-3 mt-2", children: title }), !noSearch && (_jsx(Search, { data: data, onChange: function (e, filteredItems) { return setFilteredItems(filteredItems); } })), generateRenders(filteredItems || data, 0, onItemSelect)] }));
};
export default TreeList;
//# sourceMappingURL=TreeList.js.map