import { __assign, __read } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from "react";
import { AlphabetFilter, CategoryFilter, DropDown } from "../..";
import Helper from "../../../utils/helper";
import "./Filters.component.scss";
var Filters = function (props) {
    var config = props.config, data = props.data, initialFilters = props.initialFilters, onFilterChange = props.onFilterChange;
    var _a = __read(useState(initialFilters), 2), filters = _a[0], setFilters = _a[1];
    var total = data && data.length;
    var countOptions = Helper.generateSlices(total || 0, config.count || 0, "range");
    var onLocalFilterChange = function (data, type) {
        var filterClone = filters ? __assign({}, filters) : {};
        var existing = filterClone[type];
        if (existing &&
            type !== "count" &&
            data &&
            type === "alphabet" &&
            "value" in existing &&
            "value" in data &&
            existing.value === data.value) {
            filterClone[type] = undefined;
        }
        else {
            filterClone[type] = data;
        }
        setFilters(filterClone);
        onFilterChange && onFilterChange(filterClone);
    };
    return (_jsxs("div", { className: "c-Filters p-3 h-100 overflow-auto", children: [_jsx("h4", { children: "Filters" }), "count" in config && (_jsx(DropDown, { context: "count", id: "icon-range-selector", label: "Select a range", options: countOptions, onSelectionChanged: function (data) {
                    onLocalFilterChange(data, "count");
                } })), config.alphabet && (_jsx(AlphabetFilter, { onSelectionChanged: onLocalFilterChange })), "categories" in config && (_jsx(CategoryFilter, { categoryGroups: Helper.generateCategories(data, config.categories), onCategorySelection: function (data, category) {
                    var categories = filters && filters.categories ? filters.categories : new Map();
                    "set" in categories && categories.set(category, data);
                    onLocalFilterChange(categories, "categories");
                } }))] }));
};
export default Filters;
//# sourceMappingURL=Filters.js.map