import { ChangeEvent } from "react";
import "./Search.component.scss";
interface BaseSearchProps {
    classes?: string;
    data: Array<SearchItem>;
    placeholder?: string;
}
interface SearchPropsWithOnClick extends BaseSearchProps {
    onChange: (event: ChangeEvent<HTMLInputElement>, filteredItems: Array<SearchItem> | null) => void;
}
interface SearchPropsWithPopperPrevented extends BaseSearchProps {
    showPopUp: boolean;
}
type SearchProps = SearchPropsWithOnClick | SearchPropsWithPopperPrevented;
declare const Search: (props: SearchProps) => JSX.Element;
export default Search;
