import { __awaiter, __generator, __read } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useState } from "react";
import { Filters } from "../../components";
import Footer from "../../components/Footer";
import Main from "../../components/Main";
import Header from "../../components/Header";
import IconsList from "../../components/IconsList";
import Network from "../../utils/network";
import Helper from "../../utils/helper";
import "./Icons.page.scss";
var fetchData = function (setIcons) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, Network.getStatic("/icons", null, null)];
            case 1:
                response = _a.sent();
                setIcons(response.body);
                return [2 /*return*/];
        }
    });
}); };
var Icons = function (props) {
    var _a = __read(useState(), 2), icons = _a[0], setIcons = _a[1];
    var _b = __read(useState(), 2), searchText = _b[0], setSearchText = _b[1];
    var _c = __read(useState(), 2), filteredIcons = _c[0], setFilteredIcons = _c[1];
    var _d = __read(useState({
        count: {
            value: "1to1000",
            data: new Map([
                ["startIndex", 0],
                ["endIndex", 999],
            ]),
        },
    }), 2), filters = _d[0], setFilters = _d[1];
    useEffect(function () {
        !icons && fetchData(setIcons);
    }, [icons]);
    useEffect(function () {
        if (icons) {
            var finalFilteredIconList_1 = icons;
            if (searchText) {
                finalFilteredIconList_1 = Helper.recrusiveFilter(finalFilteredIconList_1, searchText, false, ["name"]);
            }
            if (filters && finalFilteredIconList_1) {
                var countFilter = filters.count && "data" in filters.count && filters.count.data;
                if (countFilter) {
                    finalFilteredIconList_1 = finalFilteredIconList_1.slice(countFilter.get("startIndex"), countFilter.get("endIndex"));
                }
                var alphabet_1 = filters.alphabet &&
                    "value" in filters.alphabet &&
                    filters.alphabet.value;
                if (alphabet_1) {
                    finalFilteredIconList_1 = finalFilteredIconList_1.filter(function (icon) {
                        return icon.name.toLowerCase().startsWith(alphabet_1.toLowerCase());
                    });
                }
                var categories = filters.categories && filters.categories;
                if (categories) {
                    Array.from(categories.keys()).forEach(function (category) {
                        finalFilteredIconList_1 = finalFilteredIconList_1 === null || finalFilteredIconList_1 === void 0 ? void 0 : finalFilteredIconList_1.filter(function (icon) {
                            return icon.group === category;
                        });
                    });
                }
            }
            setFilteredIcons(finalFilteredIconList_1);
        }
    }, [filters, icons, searchText]);
    return (_jsxs("div", { className: "c-Icons vh-100 d-flex flex-column", children: [_jsx(Header, {}), _jsx(Main, { drawerContent: _jsx(Filters, { config: { count: 1000, alphabet: true, categories: ["group"] }, data: icons, initialFilters: filters, onFilterChange: setFilters }), 
                // mainContent={<IconsList icons={filteredIcons || icons} />}
                mainContent: _jsx(IconsList, { icons: filteredIcons, onSearchChanged: setSearchText }) }), _jsx(Footer, {})] }));
};
export default Icons;
//# sourceMappingURL=Icons.js.map